var query = new TSqlQueryV2(T_SQLCNT_POOL.getSqlDatabase());
query.begin();
try {
    var inserter = new TSqlInserterV2;

    var saveData = this.uiLoader().getAllValues();
    saveData["name"] = _.format("{0}", saveData["username"]);
    var mailFields = ["mail", "name"];
    var mailFields = ["mail", "name"];
    inserter.setTable("pub_contacts");
    inserter.setData(saveData);
    inserter.setField(mailFields);
    inserter.setUniqueField("id");
    inserter.setAutoIncrementField("id");
    var contcatid = query.replaceRow(inserter);
    var mailError = query.lastError();
    if (mailError.isValid()) {
        throw mailError;
    }
    
    saveData["id"] = _.format("{0}", this.selectedItems());
    saveData["contcat_id"] = _.format("{0}", contcatid);
    var userFields = ["username", "fullname", "contcat_id", "staffid", "remark", "status"];
    inserter.setTable("sys_user");
    inserter.setData(saveData);
    inserter.setField(userFields);
    inserter.setUniqueField("id");
    inserter.setAutoIncrementField("id");
    var resultId = query.replaceRow(inserter);
    var Error = query.lastError();
    if (Error.isValid()) {
        throw Error;
    }

    query.commit();
    this.alertOk(this.ttr("Data saved"));
    this.detailSaved(_.toString(resultId));
    this.setIsDetailModified(false);
} catch(e) {
    query.rollback();
    this.alertError(this.ttr("Save data failed!"));
    print(e);
}
/*---ACTION---
ICON: "save"
LABEL: "Save"
LABEL_ZHCN: "保存"
LABEL_ZHTW: "保存"
ACCEL: "Ctrl+S"
TOOLTIP: "Save"
TOOLTIP_ZHCN: "保存"
TOOLTIP_ZHTW: "保存"
PERMISSION: ""
CHECKED: ""
GROUP: ""
STYLE: " button_style=both"
LANG: "JavaScript"
STATUS: "Release"
VERSION: "1"
STATEHOOK: "return (this.isDetailModified()) ? 'enable' : 'disable';"
---ACTION---*/